#include <stdio.h>
#include <stdlib.h>

static int n,m;
static double *x,*result;

void initvars(int n_,int m_,double *x_,double *result_)
{
   n = n_;
   m = m_;
   x = x_;
   result = result_;
}

void rowmean()
{
   int i,j;
   for(i=0;i<n;i++){
      result[i] = 0;
      for(j=0;j<m;j++)result[i] += x[j + i * n];
      result[i] /= (double)m;
      }
}

void colmean()
{
   int i,j;
   for(j=0;j<m;j++){
      result[j] = 0;
      for(i=0;i<n;i++)result[j] += x[j + i * n];
      result[j] /= (double)n;
      }
   }

void colmax()
{
   int i,j;
   for(j=0;j<m;j++){
      result[j] = -1e-20;
      for(i=0;i<n;i++)if(x[j + i * n] > result[j])result[j] = x[j + i * n];
      }
}
