#include <stdio.h>
#include <stdlib.h>

double *dmalloc(unsigned long);

void domat(char *filename,int n,int m,int nans,double *ans,void(*thefun)())
{
   FILE *f;
   int i,j;
   double *x;

   
   f = fopen(filename,"r");
   if(f == NULL){
     fprintf(stderr,"Couldn't open %s for reading\n",filename);
     exit(1);
     }

   x = dmalloc(n * m);

   for(i=0;i<n;i++)
      for(j=0;j<m;j++)
         fscanf(f,"%lf",x + i * n + j);
 
   initvars(n,m,x,ans);
   (*thefun)();
}

